import { Subject } from 'rxjs/Subject';
import { DomController, DomCallback } from './dom-controller';
export declare class ScrollView {
    private _dom;
    ev: ScrollEvent;
    isScrolling: boolean;
    scrollStart: Subject<ScrollEvent>;
    scroll: Subject<ScrollEvent>;
    scrollEnd: Subject<ScrollEvent>;
    initialized: boolean;
    private _el;
    private _js;
    private _t;
    private _l;
    private _lsn;
    private _endTmr;
    constructor(_dom: DomController);
    init(ele: HTMLElement, contentTop: number, contentBottom: number): void;
    private enableNativeScrolling();
    enableJsScroll(contentTop: number, contentBottom: number): void;
    getTop(): number;
    getLeft(): number;
    setTop(top: number): void;
    setLeft(left: number): void;
    scrollTo(x: number, y: number, duration: number, done?: Function): Promise<any>;
    scrollToTop(duration: number): Promise<any>;
    scrollToBottom(duration: number): Promise<any>;
    stop(): void;
    destroy(): void;
}
export interface ScrollEvent {
    timeStamp: number;
    scrollTop: number;
    scrollLeft: number;
    startY: number;
    startX: number;
    deltaY: number;
    deltaX: number;
    velocityY: number;
    velocityX: number;
    directionY: string;
    directionX: string;
    domWrite: {
        (fn: DomCallback, ctx?: any);
    };
    contentElement: HTMLElement;
    fixedElement: HTMLElement;
    scrollElement: HTMLElement;
    headerElement: HTMLElement;
    footerElement: HTMLElement;
}
